{% extends "gamestradamus/base.html" %}
{% import 'gamestradamus/numbers.html' as numbers %}

{# For a specific game, show a list of accounts and their value breakdown #}

{% block title %}{{ game.name }}{% endblock %}
{% block description %}Analytics for {{ game.name }} from the Gauge community.{% endblock %}

{% block header %}
    <article class="game">

        <div class="info" data-base-price="{{ "%.2f"|format(game.price|default(0, True)) }}" data-base-cost-per-hour="{{ "%.2f"|format(game.community_value_base_price) }}">
            <a href="http://store.steampowered.com/app/{{ game.app_id }}/" target="_blank" class="thumb" title="View on Steam">
                <img src="{{ request.config['gauge.steam_cdn'] }}{{ game.app_id }}/header_292x136.jpg" width="292" height="136">
                {% if game.on_sale %}
                    <div class="overlay">&nbsp;</div>
                {% endif %}
            </a>
            <h1 {% if game.name|length > 50 %}style="font-size: 30px;"{% endif %}>{{ game.name }}</h1>

            <div class="details">
                {% if game.sale_price or game.price %}
                    <p class="price">
                        {% if game.on_sale %}
                            -{{ game.percent_off|round|int }}%&nbsp;<span>|</span>&nbsp;{{ numbers.format_price_with_symbol(region, game.sale_price) }}&nbsp;
                            <del>{{ numbers.format_price_with_symbol(region, game.price) }}</del>
                        {% else %}
                            {{ numbers.format_price_with_symbol(region, game.price) }}
                        {% endif %}
                    </p>
                {% endif %}
                <a href="http://store.steampowered.com/app/{{ game.app_id }}/" target="_blank" class="steam">
                    View on Steam
                </a>

                <span id="watchlist-interface">
                    <a id="add-to-watchlist" class="add watchlist {% if watch %}hidden{% endif %}" data-game-id="{{ game.id }}">Add to Watchlist</a>
                    <a id="on-watchlist" class="on watchlist {% if not watch %}hidden{% endif %}" href="/profile/watchlist/#game-{{ game.id }}">On Watchlist</a>
                </span>

                <span id="add-to-library-interface">
                    <a id="add-to-library" class="add manually-added {% if user_account_game %}hidden{% endif %}" href="/profile/games/" data-game-id="{{ game.id }}">Add to Library</a>
                    <a id="restore-to-library" class="restore manually-added {% if not user_account_game or not user_account_game.ignore %}hidden{% endif %}" href="/profile/games/" data-user-account-game-id="{{ user_account_game.id }}">Add to Library</a>
                    <a id="in-library" class="on manually-added {% if not user_account_game or user_account_game.ignore %}hidden{% endif %}" href="/profile/games/#game-{% if user_account_game %}{{ user_account_game.game_id }}{% else %}{{ game.id }}{% endif %}">View in Library</a>
                </span>
                <div class="clear"></div>

                {% if game.genre %}
                    <p class="genre">
                        <strong>Genre:</strong>&nbsp;{{ game.genre }}
                    </p>
                {% endif %}

                {% if game.release %}
                    <p class="release">
                        <strong>Release:</strong>&nbsp;{{ game.release.strftime("%b %d, %Y") }}

                        {% if game.release < now %}
                            <span>
                                {% set before = (now - game.release) %}
                                {% set years = (before.days / 365)|int %}
                                {% set months = (((before.days - years * 365) % 365) / 30.4)|int %}
    
                                {% if years > 0 or months > 0 %}
                                    &nbsp; ({% if years > 0 %}{{ years }} year{% if years > 1 %}s{% endif %}{% endif %}{% if years > 0 and months > 0 %}, {% endif %}{% if months > 0 %}{{ months }} month{% if months > 1 %}s{% endif %}{% endif %} ago)
                                {% endif %}
                            </span>
                        {% endif %}
                    </p>
                {% endif %}
            </div>
            <div class="clear"></div>
        </div>
    </article> 
{% endblock %}

{% block container %}
    <article class="game">
        <div class="community-statistics">
            <h2>
                <span>Community Value</span>
                <mark 
                    data-price="{{ "%.2f"|format(game.min_price) }}"
                    data-name="{{ game.name }}"
                >?</mark>
            </h2>

            <div class="average-cost-per-hour">
                {% if game.on_sale %}
                    <div class="stat on-sale">
                        {% set value = game.community_value %}
                        {% call(symbol) numbers.format_cost_per_hour_with_symbol(region, value) %}
                            <span class="unit">{{ symbol|safe }}</span>
                        {% endcall %}
                        <p>Cost / Hour (On Sale)</p>
                    </div>
                    <div class="stat regular-price">
                        {% set value = game.community_value_base_price %}
                        {% call(symbol) numbers.format_cost_per_hour_with_symbol(region, value) %}
                            <span class="unit">{{ symbol|safe }}</span>
                        {% endcall %}
                        <p>Cost / Hour (Regular Price)</p>
                    </div> 
                {% else %}
                    <div class="stat">
                        {% set value = game.community_value %}
                        {% call(symbol) numbers.format_cost_per_hour_with_symbol(region, value) %}
                            <span class="unit">{{ symbol|safe }}</span>
                        {% endcall %}
                        <p>Cost / Hour</p>
                    </div>
                {% endif %}
            </div>

            <div class="average-playtime">
                <div class="stat">
                    {{ numbers.format_hours(region, game.median_hours_played) }}
                </div>
                <span class="unit">hrs</span>
                <p>Median Time</p>
            </div>

            <div class="total-count">
                <div class="stat">{{ numbers.format_owner_count(region, game.owner_count|default(0, True))|thousands_separated }}</div>
                <p>Gamers</p> 
            </div>

            <div class="average-rating">
                <div class="stat">
                    {% set rating = game.community_rating %}

                    <div class="rating" data-rating="{{ "%.1f"|format(rating) }}">

                        <div class="rating-1{% if rating > 0 %} active{% endif %}">
                            <a class="rating-1" title="{{ region.numbers.format_rating(rating) }} / {{ region.numbers.format_rating(5.0) }}"><span {% if rating < 1 %}style="width: {{ (25 * rating)|round|int }}px;"{% endif %}></span></a>

                            <div class="rating-2{% if rating > 1 %} active{% endif %}">
                                <a class="rating-2" title="{{ region.numbers.format_rating(rating) }} / {{ region.numbers.format_rating(5.0) }}"><span {% if rating < 2 %}style="width: {{ (25 * (rating - 1))|round|int }}px;"{% endif %}></span></a>

                                <div class="rating-3{% if rating > 2 %} active{% endif %}">
                                    <a class="rating-3" title="{{ region.numbers.format_rating(rating) }} / {{ region.numbers.format_rating(5.0) }}"><span {% if rating < 3 %}style="width: {{ (25 * (rating - 2))|round|int }}px;"{% endif %}></span></a>

                                    <div class="rating-4{% if rating > 3 %} active{% endif %}">
                                        <a class="rating-4" title="{{ region.numbers.format_rating(rating) }} / {{ region.numbers.format_rating(5.0) }}"><span {% if rating < 4 %}style="width: {{ (25 * (rating - 3))|round|int }}px;"{% endif %}></span></a>

                                        <div class="rating-5 {% if rating > 4 %} active{% endif %}">
                                            <a class="rating-5" title="{{ region.numbers.format_rating(rating) }} / {{ region.numbers.format_rating(5.0) }}"><span {% if rating < 5 %}style="width: {{ (25 * (rating - 4))|round|int }}px;"{% endif %}></span></a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <p>Average Enjoyment (of {{ numbers.format_owner_count(region, game.rating_count|default(0, True))|thousands_separated }})</p>
            </div>
        </div>

        <div class="similar-game-list">
            <h2>
                <span>Community Play Time</span>
                <mark 
                    data-hours="{{ "%.1f"|format(game.median_hours_played|default(0, True)) }}"
                    data-name="{{ game.name }}"
                >?</mark>
            </h2>
            {% if not game.hours_played_distribution|default(False, True) %}
                <div class="no-data-message">No Data Available</div>
            {% endif %}
        </div>
        <div class="clear"></div>
    </article>
{% endblock %}

{% block scripts %}
    {{ super() }}
    <script type="text/javascript" src="{{ request.config['gauge.static_base'] }}{{ request.config['gauge.javascript_base'] }}d3/d3.min.js"></script>
    <script type="text/javascript">
        require([
            "gamestradamus/profile-game",
            "gamestradamus/region",

            "dojo/domReady!"
        ], function(init, region) {
            var data = {{ game.hours_played_distribution|default("[]", True)|safe }};
            var median = {{ "%.1f"|format(game.median_hours_played|default(0, True)) }};
            var average = {{ "%.1f"|format(game.average_hours_played|default(0, True)) }};
            var plot_hours_played_distribution = function() {
                var width = 440;
                var height = 130;

                var x = d3.scale.linear().range([0, width]);
                var y = d3.scale.linear().range([height, 0]);
                var bar_width = width / Math.max(40, data.length) - 2;
                var step = 1;
                if (data.length > 1) {
                    step = (data[data.length - 1].h - data[0].h) / 40;
                }

                var yAxis = d3
                    .svg.axis()
                    .scale(y)
                    .orient('left')
                    .tickValues([
                        0,
                        d3.max(data, function(d) { return d.c })
                    ])
                    .tickFormat(function(d) {
                        return region['format-integer'](d).replace('&nbsp;', ' ');
                    });
                var bounds = [
                    d3.min(data, function(d) { return d.h }),
                    d3.max(data, function(d) { return d.h })
                ];
                var xAxis = d3
                    .svg.axis()
                    .scale(x)
                    .orient('bottom')
                    .tickValues([
                        bounds[0],
                        Math.round((bounds[0] + bounds[1]) / 3),
                        Math.round((bounds[0] + bounds[1]) * 2 / 3),
                        bounds[1]
                    ])
                    .tickFormat(function(d) {
                        return region['format-integer'](d).replace('&nbsp;', ' ');
                    });
                var line = d3.svg.line()
                    .x(function(d) { return x(d[0]) })
                    .y(function(d) { return d[1] });

                x.domain([bounds[0], bounds[1]]);
                y.domain([0, d3.max(data, function(d) { return d.c })]);

                var svg = d3
                    .select('div.similar-game-list')
                    .append('svg')
                    .attr('width', 520)
                    .attr('height', 170)
                    .append('g')
                    .attr('transform', 'translate(50, 20)');

                function tooltip(d) {
                    return region['format-integer'](d.c).replace('&nbsp;', ' ') + 
                        ' gamers @ [' + region['format-hours'](d.h).replace('&nbsp;', ' ') + 
                        ', ' + region['format-hours'](d.h + step).replace('&nbsp;', ' ') + '] hrs';
                }
                svg.selectAll('.bar')
                    .data(data)
                    .enter()
                    .append('rect')
                    .attr('class', 'bar')
                    .attr('x', function(d) { return x(d.h) })
                    .attr('width', function(d) { return bar_width })
                    .attr('y', function(d) { return y(d.c) })
                    .attr('height', function(d) { return height - y(d.c) })
                    .attr('title', tooltip)
                    .append('title')
                    .text(tooltip);

                svg.append('path')
                    .datum([[median, height], [median, 0]])
                    .attr('class', 'median-line')
                    .attr('d', line);
                svg.append('text')
                    .attr('x', x(median) + 8)
                    .attr('y', 14)
                    .attr('class', 'median-label')
                    .text('median (' + region['format-hours'](median).replace('&nbsp;', ' ') + ' hrs)');

                svg.append('g')
                    .attr('class', 'y axis')
                    .call(yAxis)
                    .append('text')
                    .attr('transform', 'rotate(-90)')
                    .attr('y', -9)
                    .attr('x', -64)
                    .attr('class', 'label')
                    .style('text-anchor', 'middle')
                    .text('Gamers');

                svg.append('g')
                    .attr('class', 'x axis')
                    .attr('transform', 'translate(0, ' + height + ')')
                    .call(xAxis)
                    .append('text')
                    .attr('y', 18)
                    .attr('x', 212)
                    .attr('class', 'label')
                    .style('text-anchor', 'start')
                    .text('Hours');
            };
            if (data.length > 0) {
                plot_hours_played_distribution();
            }

            init();
        });
    </script>
{% endblock %}
